<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.2c (rvision 25621)
#									########################
#					Dvelopp pour VirtueMart
#						Version : 1.0.x
#						Compatibilit plateforme : V1
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						01/06/2011
#						Contact : support@payzen.eu
#						Auteur Valrie Isaksen - juin 2010 - alatak@alatak.net
#
#####################################################################################################

/*
 * Traitement du retour du client sur la boutique
*/
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );


mm_showMyFileName(__FILE__ );

global $mosConfig_lang;
require_once(CLASSPATH . 'ps_order.php' );

if(stripos($_POST['payment_config'],'MULTI') !== false || stripos($_POST['contrib'],'multi') !== false) {
	$prefix = 'VADS_MULTI_';
	require_once(CLASSPATH . 'payment/ps_vads_multi.cfg.php');
	require_once(CLASSPATH . 'payment/ps_vads_multi.php');
	// load payment Language File
	if (file_exists(PAGEPATH. 'vads_multi/languages/'.$mosConfig_lang.'.php' ))
		require_once( PAGEPATH. 'vads_multi/languages/'.$mosConfig_lang.'.php' );
	else
		require_once( PAGEPATH. 'vads_multi/languages/french.php' );

	$ps_vads = new ps_vads_multi();
	$vads_api = new VADS_MULTI_API();
}
else {
	$prefix = 'VADS_';
	require_once(CLASSPATH . 'payment/ps_vads.cfg.php');
	require_once(CLASSPATH . 'payment/ps_vads.php');
	// load payment Language File
	if (file_exists(PAGEPATH. 'vads/languages/'.$mosConfig_lang.'.php' ))
		require_once( PAGEPATH. 'vads/languages/'.$mosConfig_lang.'.php' );
	else
		require_once( PAGEPATH. 'vads/languages/french.php' );

	$ps_vads = new ps_vads();
	$vads_api = new VADS_API();
}

$vads_api->setResponseFromPost($_POST, constant($prefix.'KEY_TEST'), constant($prefix.'KEY_PROD'), constant($prefix.'MODE'));

// Filtrage des tentatives de fraude
if( ! $vads_api->isAuthentifiedResponse() ) {
    header("Location:".URL."index.php?option=com_virtuemart&page=shop.cart");
    die();
}

// La commande a-t-elle dj t enregistre ?
$order_id = mosGetParam($_REQUEST, "order_id" );
$db = new ps_DB();
$db->query( 'SELECT order_status_code FROM #__{vm}_order_history WHERE order_id='.$order_id.' ORDER BY date_added DESC' );
$db->next_record();
$order_not_confirmed = ($db==false || $db->f('order_status_code')=='P');
$order_canceled = ($db!=false && $db->f('order_status_code')=='X');

// Traitement selon le cas
if($order_canceled) {
    echo '<h2>'.$VADS_LANG->_PS_VADS_ERREUR_PAIEMENT.'</h2>';
    echo '<h3><a href="'.$url_order_history.'">'.$VADS_LANG->_PS_VADS_RETURN_TO_ORDERS_HISTORY.'</a></h3>';
}
elseif($order_not_confirmed) {
    // Commande en attente de paiement
    if($vads_api->isAcceptedPayment()) {
        // On valide la commande
        $d = array();
        $d['order_id'] = $order_id;
        $d['order_status'] = constant($prefix.'VERIFIED_STATUS');
        $d['notify_customer'] = "N";
        $d['include_comment'] = "Y";
        $d['order_comment'] = htmlentities($vads_api->getResponseMessage('detail')).
                ($vads_api->getReponse3DSec()!='' ? '<br/>'.htmlentities($vads_api->getReponse3DSec()) : "");
        $ps_order = new ps_order;
        $ps_order->order_status_update($d);

        // L'url serveur n'a pas fonctionn�, on affiche un avertissement en mode test
        if( $vads_api->get('ctx_mode')=='TEST' )
            echo '<span style="color:red">'.$VADS_LANG->_PS_VADS_IS_CHECK_URL_FILLED.'</span>';

        // Message de confirmation
        echo '<h2>'.$VADS_LANG->_PS_VADS_THANKYOU.'</h2>';
    }
    else {
        // Retour du client aprs chec du processus de paiement => mj + message + lien vers l'historique des commandes
        $d = array();
        $d['order_id'] = $order_id;
        $d['order_status'] = constant($prefix.'INVALID_STATUS');
        $d['notify_customer'] = "N";
        $d['include_comment'] = "Y";
        $d['order_comment'] = htmlentities($vads_api->getResponseMessage('detail')).
                ($vads_api->getReponse3DSec()!='' ? '<br/>'.htmlentities($vads_api->getReponse3DSec()) : "");
        $ps_order = new ps_order;
        $ps_order->order_status_update($d);

        echo '<h2>'.$VADS_LANG->_PS_VADS_ERREUR_PAIEMENT.'</h2>';
        echo '<h3><a href="'.$url_order_history.'">'.$VADS_LANG->_PS_VADS_RETURN_TO_ORDERS_HISTORY.'</a></h3>';
        //vmRedirect('index.php?page=account.index&option=com_virtuemart');
    }
}
else {
    // Commande dj accepte
    if($vads_api->isAcceptedPayment()) {
        echo '<h2>'.$VADS_LANG->_PS_VADS_THANKYOU.'</h2>';
    }
    else {
        // Erreur ! Rception d'un paiement invalide pour une commande dj enregistre
        $message  = '<span style="color:red">';
        $message .= $VADS_LANG->_PS_VADS_ERROR;
        $message .= '</span>';
        echo $message;
    }
}
?>