<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.2c (rvision 25621)
#									########################
#					Dvelopp pour VirtueMart
#						Version : 1.0.x
#						Compatibilit plateforme : V1
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						01/06/2011
#						Contact : support@payzen.eu
#						Auteur Valrie Isaksen - juin 2010 - alatak@alatak.net
#
#####################################################################################################

/*
 * Traitement de la confirmation de paiement serveur  serveur
*/
// Chargement des classes, variables...
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

mm_showMyFileName(__FILE__ );

require_once(CLASSPATH . 'ps_order.php' );
if(stripos($_POST['payment_config'],'MULTI') !== false || stripos($_POST['contrib'],'multi') !== false)
{
	$prefix = 'VADS_MULTI_';
	require_once(CLASSPATH . 'payment/ps_vads_multi.cfg.php');
	require_once(CLASSPATH . 'payment/ps_vads_multi.php');

	$ps_vads = new ps_vads_multi();
	$vads_api = new VADS_MULTI_API();
}
else {
	$prefix = 'VADS_';
	require_once(CLASSPATH . 'payment/ps_vads.cfg.php');
	require_once(CLASSPATH . 'payment/ps_vads.php');

	$ps_vads = new ps_vads();
	$vads_api = new VADS_API();
}

$vads_api->setResponseFromPost($_POST, constant($prefix.'KEY_TEST'), constant($prefix.'KEY_PROD'), constant($prefix.'MODE'));

// Filtrage des tentatives de fraude
if( ! $vads_api->isAuthentifiedResponse() ) {
    echo $vads_api->getCheckUrlResponse('auth_fail');
    die();
}

// La commande a-t-elle dj t enregistre ?
$order_id = mosGetParam($_REQUEST, "order_id" );
$db = new ps_DB();
$db->query( 'SELECT order_status_code FROM #__{vm}_order_history WHERE order_id='.$order_id.' ORDER BY date_added DESC' );
$db->next_record();
$order_not_confirmed = ($db==false || $db->f('order_status_code')=='P');
$order_canceled = ($db!=false && $db->f('order_status_code')=='X');

if($order_canceled) {
    die( $vads_api->getCheckUrlResponse('ko',"La commande est annul�e"));
}

// Traitement selon le cas
if($order_not_confirmed) {
    // Commande en attente de paiement
    if($vads_api->isAcceptedPayment()) {
        // Confirmation de la plateforme
        // On valide la commande
        $d = array();
        $d['order_id'] = $order_id;
        $d['order_status'] = constant($prefix.'VERIFIED_STATUS');
        $d['notify_customer'] = "N";
        $d['include_comment'] = "Y";
        $d['order_comment'] = htmlentities($vads_api->getResponseMessage('detail')).
                ($vads_api->getReponse3DSec()!='' ? '<br/>'.htmlentities($vads_api->getReponse3DSec()) : "");
        $ps_order = new ps_order;
        $ps_order->order_status_update($d);
        // On affiche un code de confirmation
        echo $vads_api->getCheckUrlResponse('payment_ok');
    }
    else {
        // On ajoute un historique et on change �ventuellement le statut de la commande
        $d = array();
        $d['order_id'] = $order_id;
        $d['order_status'] = constant($prefix.'INVALID_STATUS');
        $d['notify_customer'] = "N";
        $d['include_comment'] = "Y";
        $d['order_comment'] = htmlentities($vads_api->getResponseMessage('detail')).
                ($vads_api->getReponse3DSec()!='' ? '<br/>'.htmlentities($vads_api->getReponse3DSec()) : "");
        $ps_order = new ps_order;
        $ps_order->order_status_update($d);

        // Paiement invalide notifi par la plateforme
        echo $vads_api->getCheckUrlResponse('payment_ko');
    }
}
else {
    // Commande dj enregistre
    if($vads_api->isAcceptedPayment()) {
        echo $vads_api->getCheckUrlResponse('payment_ok_already_done');
    }
    else {
        echo $vads_api->getCheckUrlResponse('payment_ko_on_order_ok');
    }
}
?>