<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.2c (rvision 25621)
#									########################
#					Dvelopp pour VirtueMart
#						Version : 1.0.x
#						Compatibilit plateforme : V1
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						01/06/2011
#						Contact : support@payzen.eu
#						Auteur Valrie Isaksen - juin 2010 - alatak@alatak.net
#
#####################################################################################################

class ps_vads_Language extends mosAbstractLanguage {
	var $_VADS_SITE_ID= 'Site name';
	var $_VADS_SITE_ID_INFO= 'Set during the registration of the trader (see PayZen)';

	var $_VADS_LIEN_BANQUE= 'Link CGI Bank';
	var $_VADS_LIEN_BANQUE_INFO= 'URL of the payment platform PayZen';

	var $_VADS_MODE= 'Mode';
	var $_VADS_MODE_TEST= 'Test';
	var $_VADS_MODE_PRODUCTION= 'Production';
	var $_VADS_MODE_INFO= 'Solicitation mode of the platform (TEST or PRODUCTION)';

	var $_VADS_LANGAGE_DEFAUT= 'Default Language';
	var $_VADS_LANGAGE_DEFAUT_ALLEMAND= 'German';
	var $_VADS_LANGAGE_DEFAUT_ANGLAIS= 'English';
	var $_VADS_LANGAGE_DEFAUT_CHINOIS= 'Chinese';
	var $_VADS_LANGAGE_DEFAUT_ESPAGNOL= 'Spanish';
	var $_VADS_LANGAGE_DEFAUT_FRANCAIS= 'French';
	var $_VADS_LANGAGE_DEFAUT_ITALIEN= 'Italian';
	var $_VADS_LANGAGE_DEFAUT_JAPONAIS= 'Spanish';
	var $_VADS_LANGAGE_DEFAUT_INFO= 'Language of the payment page';

	var $_VADS_DELAY= 'Deadline';
	var $_VADS_DELAY_INFO= 'In days before returned to bank (if empty, use default PayZen)';

	var $_VADS_CARTE_DISPO= 'Card(s)';
	var $_VADS_CARTE_DISPO_TOUS= 'All';
	var $_VADS_CARTE_DISPO_AMEX= 'Amex';
	var $_VADS_CARTE_DISPO_MASTERCARD= 'Mastercard';
	var $_VADS_CARTE_DISPO_CB= 'CB';
	var $_VADS_CARTE_DISPO_VISA= 'Visa';
	var $_VADS_CARTE_DISPO_INFO= 'List of types of cards available for trade';

	var $_VADS_TYPE_VALIDATION= 'Validation Type';
	var $_VADS_TYPE_VALIDATION_AUTOMATIQUE= 'Automatic';
	var $_VADS_TYPE_VALIDATION_MANUELLE= 'Manual';
	var $_VADS_TYPE_VALIDATION_INFO= 'If manual validation of the merchant';

	var $_VADS_KEY_TEST= 'Certificate in test mode';
	var $_VADS_KEY_PROD= 'Certificate in production mode';
	var $_VADS_CERTIFICAT_INFO= 'Certificate provided by the Bank';

	var $_PS_VADS_URL_SILENCIEUSE= 'Url silent';
	var $_PS_VADS_URL_SILENCIEUSE_INFO= 'URL to paste in the back office of the PayZen (URL server store)';


	var $_PS_VADS_ORDER_OK= 'status of the transaction accepted';
	var $_PS_VADS_ORDER_OK_INFO= 'Select the status of the order lorque payment is accepted.
If you use the system to download for your products: select the status that allows the download to the client (so the customer will immediately receive an email with a key to download). ';
	var $_PS_VADS_ORDER_KO= 'status of the transaction refused';
	var $_PS_VADS_ORDER_KO_INFO= 'Select the status of the order lorque payment is refused. ';
	var $_PS_VADS_CONFIG_ERROR= 'Unable to write to the configuration file:';
	var $_PS_VADS_PAYMENT_I= 'Immediate';
	var $_PS_VADS_PAYMENT_D= 'Deferred';
	var $_PS_VADS_MEMBER= 'Bank';
	var $_PS_VADS_MEMBER_INFO= 'The name of the bank with which you deal';

	var $_VADS_MONNAIE= 'Currency';
	var $_VADS_MONNAIE_INFO= 'currency to use in ISO 4217 (http://www.iso.org/iso/support/currency_codes_list-1.htm)';

	var $_PS_VADS_PAYMENT_SUCCESS= 'Authorization for payment has been accepted';
	// Send in email and browser
	var $_PS_VADS_PAYMENT_NOT_SUCCESS= 'We\'re sorry. The authorization of payment has not been accepted. <br />
The server e-transactions has returned the following message: <br /> ';
	var $_PS_VADS_ORDER_STATUS= 'The status of your order is:';
	var $_PS_VADS_THANKYOU= 'Thank you for your payment. The payment was completed successfully. ';
	var $_PS_VADS_THANK_YOU= 'Thank you for your order';
	var $_PS_VADS_TENTATIVE_FRAUDE= 'Attempt to fraud, error signature BP';
	var $_PS_VADS_ERREUR_PAIEMENT= 'Payment has not been made';
	var $_PS_VADS_RETURN_TO_ORDERS_HISTORY= 'Return to orders history';

	var $_PS_VADS_CONTRIB_PARAM= 'Plugin version';
	var $_PS_VADS_CONTRIB_PARAM_INFO= 'Plugin identifier sent to the gateway';

	var $_PS_VADS_EXTRA_CODE= 'Code &agrave; copier ci-dessous';
	var $_PS_VADS_EXTRA_CODE_INFO= 'Code &agrave; renseigner dans "Payment Extra info"';

	var $_PS_VADS_ERROR= 'Une erreur est survenue.';
	var $_PS_VADS_IS_CHECK_URL_FILLED= 'Commande enregistr&eacute;e, mais la confirmation automatique n\'a pas fonctionn&eacute;. Avez-vous correctement renseign&eacute; l\'url serveur dans l\'outil de gestion de caisse ?';
}
$VADS_LANG =& new ps_vads_Language();
?>